(function webpackUniversalModuleDefinition(root, factory) {
	if(typeof exports === 'object' && typeof module === 'object')
		module.exports = factory();
	else if(typeof define === 'function' && define.amd)
		define("react-interactive-highlighter", [], factory);
	else if(typeof exports === 'object')
		exports["react-interactive-highlighter"] = factory();
	else
		root["react-interactive-highlighter"] = factory();
})(self, function() {
return /******/ (() => { // webpackBootstrap
/******/ 	"use strict";
/******/ 	var __webpack_modules__ = ({

/***/ 259:
/***/ (function(__unused_webpack_module, exports, __webpack_require__) {


var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", ({ value: true }));
exports.InteractiveHighlighter = void 0;
var react_1 = __importStar(__webpack_require__(294));
// true if arrays consist of the same primitives (in the same order)
function arraysEqual(a, b) {
    if (a === b)
        return true;
    if (a == null || b == null)
        return false;
    if (a.length !== b.length)
        return false;
    for (var i = 0; i < a.length; ++i) {
        if (a[i] !== b[i])
            return false;
    }
    return true;
}
/**
 * InteractiveHighlighter component.
 *
 * Allows highlighting of the text selected by user with given custom class (or default)
 * and calls optional callback function with the following selection details:
 * - selected text
 * - selection start index
 * - selection end index
 *
 * Supports pre-existing highlights passed through the "highlights" property.
 *
 * It is difficult to unit test the DOM-based selection API, so this class supports a property
 * providing a mock that can be used to return the start & length of a selection. This is
 * intended only for use in tests.
 */
var InteractiveHighlighter = /** @class */ (function (_super) {
    __extends(InteractiveHighlighter, _super);
    function InteractiveHighlighter(props) {
        var _this = _super.call(this, props) || this;
        if (_this.props.getSelectionFn) {
            _this._getSelectionMarker = _this.props.getSelectionFn;
        }
        else {
            _this._getSelectionMarker = _this._getSelectionFromDOM;
        }
        _this.onMouseUpHandler = _this.onMouseUpHandler.bind(_this);
        if (_this.props.customClassFn) {
            _this._customClassFn = _this.props.customClassFn;
        }
        else {
            _this._customClassFn = function (highlightIndexes) {
                if (highlightIndexes.length > 0) {
                    return _this.props.customClass || "default";
                }
                return "";
            };
        }
        _this._segments = [];
        return _this;
    }
    InteractiveHighlighter.prototype._getSelectionFromDOM = function () {
        var selectionObj = window.getSelection();
        if (!selectionObj) {
            console.error("getSelection() returned null");
            return null;
        }
        // anchorNode is the node in which the selection begins; focusNode that
        //  in which it ends. (See https://developer.mozilla.org/en-US/docs/Web/API/Selection.)
        var selection = selectionObj.toString();
        var anchorNode = selectionObj.anchorNode;
        var focusNode = selectionObj.focusNode;
        var anchorOffset = selectionObj.anchorOffset;
        var focusOffset = selectionObj.focusOffset;
        // did we select "forward" or backward?
        var relativePosition;
        var isForwardSelection = false;
        if (anchorNode && focusNode) { // wrapped to stop compiler warnings about possible null-ness
            relativePosition = anchorNode.compareDocumentPosition(focusNode);
        }
        else {
            console.warn("Returning from onMouseUpHandler because anchorNode or focusNode are null");
            return null;
        }
        /* eslint-disable-next-line @typescript-eslint/no-non-null-assertion */
        if (relativePosition === anchorNode.DOCUMENT_POSITION_FOLLOWING) {
            isForwardSelection = true;
        }
        else if (relativePosition === 0) {
            isForwardSelection = (focusOffset - anchorOffset) > 0;
        }
        var selectionStart = isForwardSelection ? anchorOffset : focusOffset;
        // figure out the actual absolute index of the selection (in the original string) - to do
        //  this we need to account for the spans that might have been rendered in order to handle
        //  highlights that already exist.
        var parent;
        if (isForwardSelection) {
            if (anchorNode.parentNode) {
                parent = anchorNode.parentNode;
            }
            else {
                console.error("Ended up with null anchorNode.parentNode - should be impossible!");
                return null;
            }
        }
        else {
            if (focusNode.parentNode) {
                parent = focusNode.parentNode;
            }
            else {
                console.error("Ended up with null focusNode.parentNode - should be impossible!");
                return null;
            }
        }
        // adjust selectionStart to reflect the index into the whole text (not just the current segment)
        if (parent.getAttribute('data-segment')) {
            var segmentNum = Number(parent.getAttribute('data-segment'));
            selectionStart += this._segments[segmentNum].start;
        }
        // clear selection
        selectionObj.removeAllRanges();
        return { selectionStart: selectionStart, selectionLength: selection.length };
    };
    // Note: a "segment" is a string in which each char is highlighted the same way. When there are no
    //  overlapping highlights, segments are simply highlights and the non-highlighted text
    //  between them. When there are overlapping highlights, segments distinguish text
    //  in highlight A from text in highlights A and B from text in highlight C (and so forth).
    InteractiveHighlighter.prototype._computeSegments = function () {
        var highlights = this.props.highlights;
        var segments = [];
        var segmentStart = 0;
        var currentHighlights = [];
        var _loop_1 = function (idx) {
            // build an array of booleans corresponding to each highlight - true means
            //  the current character is in the given highlight
            var highlightsIncludingThisChar = highlights.map(function (h) { return (idx >= Number(h.startIndex)) && (idx < Number(h.startIndex) + Number(h.numChars)) ? true : false; });
            if (!arraysEqual(currentHighlights, highlightsIncludingThisChar)) {
                // the current character is the start of the next segment
                if (idx > 0) {
                    segments.push({
                        start: segmentStart,
                        end: idx - 1,
                        // the highlights array has a number for each highlight this segment is part of
                        // (this uses -1 to satisfy the compiler - null might make more sense)
                        highlights: currentHighlights.map(function (e, i) { return e ? i : -1; }).filter(function (e) { return e !== -1; })
                    });
                    segmentStart = idx;
                }
                currentHighlights = highlightsIncludingThisChar.slice();
            }
        };
        for (var idx = 0; idx < this.props.text.length; idx++) {
            _loop_1(idx);
        }
        if (segments.length === 0) {
            // special case - no highlights
            segments.push({ start: 0, end: this.props.text.length, highlights: [] });
        }
        else {
            // record the final segment
            segments.push({
                start: segmentStart,
                end: this.props.text.length,
                highlights: currentHighlights.map(function (e, i) { return e ? i : -1; }).filter(function (e) { return e !== -1; })
            });
        }
        return (segments);
    };
    InteractiveHighlighter.prototype.onMouseUpHandler = function (e) {
        e.preventDefault();
        var marker = this._getSelectionMarker();
        if (marker && marker.selectionLength) {
            var selection = this.props.text.substr(marker.selectionStart, marker.selectionLength);
            if (this.props.selectionHandler) {
                this.props.selectionHandler(selection, marker.selectionStart, marker.selectionLength);
            }
        }
    };
    InteractiveHighlighter.prototype.render = function () {
        this._segments = this._computeSegments();
        var textContent = this.props.text;
        var markedUp = [];
        for (var segmentNum = 0; segmentNum < this._segments.length; segmentNum++) {
            var spanStart = this._segments[segmentNum].start;
            var spanLen = this._segments[segmentNum].end - this._segments[segmentNum].start + 1;
            if (this._segments[segmentNum].highlights.length > 0) {
                // highlighted
                markedUp.push(react_1.default.createElement("span", { key: "d" + segmentNum, "data-segment": segmentNum, className: this._customClassFn(this._segments[segmentNum].highlights) }, textContent.substr(spanStart, spanLen)));
            }
            else {
                // non-highlighted
                markedUp.push(react_1.default.createElement("span", { key: "d" + segmentNum, "data-segment": segmentNum, className: this._customClassFn(this._segments[segmentNum].highlights) }, textContent.substr(spanStart, spanLen)));
            }
        }
        return (react_1.default.createElement("span", { onMouseUp: this.onMouseUpHandler }, markedUp));
    };
    return InteractiveHighlighter;
}(react_1.Component));
exports.InteractiveHighlighter = InteractiveHighlighter;


/***/ }),

/***/ 418:
/***/ ((module) => {

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/


/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

module.exports = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};


/***/ }),

/***/ 408:
/***/ ((__unused_webpack_module, exports, __webpack_require__) => {

/** @license React v16.14.0
 * react.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var l=__webpack_require__(418),n="function"===typeof Symbol&&Symbol.for,p=n?Symbol.for("react.element"):60103,q=n?Symbol.for("react.portal"):60106,r=n?Symbol.for("react.fragment"):60107,t=n?Symbol.for("react.strict_mode"):60108,u=n?Symbol.for("react.profiler"):60114,v=n?Symbol.for("react.provider"):60109,w=n?Symbol.for("react.context"):60110,x=n?Symbol.for("react.forward_ref"):60112,y=n?Symbol.for("react.suspense"):60113,z=n?Symbol.for("react.memo"):60115,A=n?Symbol.for("react.lazy"):
60116,B="function"===typeof Symbol&&Symbol.iterator;function C(a){for(var b="https://reactjs.org/docs/error-decoder.html?invariant="+a,c=1;c<arguments.length;c++)b+="&args[]="+encodeURIComponent(arguments[c]);return"Minified React error #"+a+"; visit "+b+" for the full message or use the non-minified dev environment for full errors and additional helpful warnings."}
var D={isMounted:function(){return!1},enqueueForceUpdate:function(){},enqueueReplaceState:function(){},enqueueSetState:function(){}},E={};function F(a,b,c){this.props=a;this.context=b;this.refs=E;this.updater=c||D}F.prototype.isReactComponent={};F.prototype.setState=function(a,b){if("object"!==typeof a&&"function"!==typeof a&&null!=a)throw Error(C(85));this.updater.enqueueSetState(this,a,b,"setState")};F.prototype.forceUpdate=function(a){this.updater.enqueueForceUpdate(this,a,"forceUpdate")};
function G(){}G.prototype=F.prototype;function H(a,b,c){this.props=a;this.context=b;this.refs=E;this.updater=c||D}var I=H.prototype=new G;I.constructor=H;l(I,F.prototype);I.isPureReactComponent=!0;var J={current:null},K=Object.prototype.hasOwnProperty,L={key:!0,ref:!0,__self:!0,__source:!0};
function M(a,b,c){var e,d={},g=null,k=null;if(null!=b)for(e in void 0!==b.ref&&(k=b.ref),void 0!==b.key&&(g=""+b.key),b)K.call(b,e)&&!L.hasOwnProperty(e)&&(d[e]=b[e]);var f=arguments.length-2;if(1===f)d.children=c;else if(1<f){for(var h=Array(f),m=0;m<f;m++)h[m]=arguments[m+2];d.children=h}if(a&&a.defaultProps)for(e in f=a.defaultProps,f)void 0===d[e]&&(d[e]=f[e]);return{$$typeof:p,type:a,key:g,ref:k,props:d,_owner:J.current}}
function N(a,b){return{$$typeof:p,type:a.type,key:b,ref:a.ref,props:a.props,_owner:a._owner}}function O(a){return"object"===typeof a&&null!==a&&a.$$typeof===p}function escape(a){var b={"=":"=0",":":"=2"};return"$"+(""+a).replace(/[=:]/g,function(a){return b[a]})}var P=/\/+/g,Q=[];function R(a,b,c,e){if(Q.length){var d=Q.pop();d.result=a;d.keyPrefix=b;d.func=c;d.context=e;d.count=0;return d}return{result:a,keyPrefix:b,func:c,context:e,count:0}}
function S(a){a.result=null;a.keyPrefix=null;a.func=null;a.context=null;a.count=0;10>Q.length&&Q.push(a)}
function T(a,b,c,e){var d=typeof a;if("undefined"===d||"boolean"===d)a=null;var g=!1;if(null===a)g=!0;else switch(d){case "string":case "number":g=!0;break;case "object":switch(a.$$typeof){case p:case q:g=!0}}if(g)return c(e,a,""===b?"."+U(a,0):b),1;g=0;b=""===b?".":b+":";if(Array.isArray(a))for(var k=0;k<a.length;k++){d=a[k];var f=b+U(d,k);g+=T(d,f,c,e)}else if(null===a||"object"!==typeof a?f=null:(f=B&&a[B]||a["@@iterator"],f="function"===typeof f?f:null),"function"===typeof f)for(a=f.call(a),k=
0;!(d=a.next()).done;)d=d.value,f=b+U(d,k++),g+=T(d,f,c,e);else if("object"===d)throw c=""+a,Error(C(31,"[object Object]"===c?"object with keys {"+Object.keys(a).join(", ")+"}":c,""));return g}function V(a,b,c){return null==a?0:T(a,"",b,c)}function U(a,b){return"object"===typeof a&&null!==a&&null!=a.key?escape(a.key):b.toString(36)}function W(a,b){a.func.call(a.context,b,a.count++)}
function aa(a,b,c){var e=a.result,d=a.keyPrefix;a=a.func.call(a.context,b,a.count++);Array.isArray(a)?X(a,e,c,function(a){return a}):null!=a&&(O(a)&&(a=N(a,d+(!a.key||b&&b.key===a.key?"":(""+a.key).replace(P,"$&/")+"/")+c)),e.push(a))}function X(a,b,c,e,d){var g="";null!=c&&(g=(""+c).replace(P,"$&/")+"/");b=R(b,g,e,d);V(a,aa,b);S(b)}var Y={current:null};function Z(){var a=Y.current;if(null===a)throw Error(C(321));return a}
var ba={ReactCurrentDispatcher:Y,ReactCurrentBatchConfig:{suspense:null},ReactCurrentOwner:J,IsSomeRendererActing:{current:!1},assign:l};exports.Children={map:function(a,b,c){if(null==a)return a;var e=[];X(a,e,null,b,c);return e},forEach:function(a,b,c){if(null==a)return a;b=R(null,null,b,c);V(a,W,b);S(b)},count:function(a){return V(a,function(){return null},null)},toArray:function(a){var b=[];X(a,b,null,function(a){return a});return b},only:function(a){if(!O(a))throw Error(C(143));return a}};
exports.Component=F;exports.Fragment=r;exports.Profiler=u;exports.PureComponent=H;exports.StrictMode=t;exports.Suspense=y;exports.__SECRET_INTERNALS_DO_NOT_USE_OR_YOU_WILL_BE_FIRED=ba;
exports.cloneElement=function(a,b,c){if(null===a||void 0===a)throw Error(C(267,a));var e=l({},a.props),d=a.key,g=a.ref,k=a._owner;if(null!=b){void 0!==b.ref&&(g=b.ref,k=J.current);void 0!==b.key&&(d=""+b.key);if(a.type&&a.type.defaultProps)var f=a.type.defaultProps;for(h in b)K.call(b,h)&&!L.hasOwnProperty(h)&&(e[h]=void 0===b[h]&&void 0!==f?f[h]:b[h])}var h=arguments.length-2;if(1===h)e.children=c;else if(1<h){f=Array(h);for(var m=0;m<h;m++)f[m]=arguments[m+2];e.children=f}return{$$typeof:p,type:a.type,
key:d,ref:g,props:e,_owner:k}};exports.createContext=function(a,b){void 0===b&&(b=null);a={$$typeof:w,_calculateChangedBits:b,_currentValue:a,_currentValue2:a,_threadCount:0,Provider:null,Consumer:null};a.Provider={$$typeof:v,_context:a};return a.Consumer=a};exports.createElement=M;exports.createFactory=function(a){var b=M.bind(null,a);b.type=a;return b};exports.createRef=function(){return{current:null}};exports.forwardRef=function(a){return{$$typeof:x,render:a}};exports.isValidElement=O;
exports.lazy=function(a){return{$$typeof:A,_ctor:a,_status:-1,_result:null}};exports.memo=function(a,b){return{$$typeof:z,type:a,compare:void 0===b?null:b}};exports.useCallback=function(a,b){return Z().useCallback(a,b)};exports.useContext=function(a,b){return Z().useContext(a,b)};exports.useDebugValue=function(){};exports.useEffect=function(a,b){return Z().useEffect(a,b)};exports.useImperativeHandle=function(a,b,c){return Z().useImperativeHandle(a,b,c)};
exports.useLayoutEffect=function(a,b){return Z().useLayoutEffect(a,b)};exports.useMemo=function(a,b){return Z().useMemo(a,b)};exports.useReducer=function(a,b,c){return Z().useReducer(a,b,c)};exports.useRef=function(a){return Z().useRef(a)};exports.useState=function(a){return Z().useState(a)};exports.version="16.14.0";


/***/ }),

/***/ 294:
/***/ ((module, __unused_webpack_exports, __webpack_require__) => {



if (true) {
  module.exports = __webpack_require__(408);
} else {}


/***/ })

/******/ 	});
/************************************************************************/
/******/ 	// The module cache
/******/ 	var __webpack_module_cache__ = {};
/******/ 	
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/ 		// Check if module is in cache
/******/ 		var cachedModule = __webpack_module_cache__[moduleId];
/******/ 		if (cachedModule !== undefined) {
/******/ 			return cachedModule.exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = __webpack_module_cache__[moduleId] = {
/******/ 			// no module.id needed
/******/ 			// no module.loaded needed
/******/ 			exports: {}
/******/ 		};
/******/ 	
/******/ 		// Execute the module function
/******/ 		__webpack_modules__[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/ 	
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/ 	
/************************************************************************/
/******/ 	
/******/ 	// startup
/******/ 	// Load entry module and return exports
/******/ 	// This entry module is referenced by other modules so it can't be inlined
/******/ 	var __webpack_exports__ = __webpack_require__(259);
/******/ 	
/******/ 	return __webpack_exports__;
/******/ })()
;
});
//# sourceMappingURL=my-lib.js.map